clc
clear all

M=1000;
theta_initial=3;
est=ones(M,2);

for j=1:M
   U_sim=clayton_copula(j, 4, 2, 1000); 
   u=U_sim(:,1); v=U_sim(:,2); 
   tau_clayton=corr(u,v,'Type','Kendall');
   est(j,1)=2*tau_clayton/(1-tau_clayton);
   est(j,2)=fminsearch(@(x) logL(u,v,x),theta_initial);
end

boxplot(est,'Labels',{'Method of Moments','Maximum Likelihood'});
ylabel('Estimates of Theta for Clayton Copula');
