% source: https://github.com/stochasticresearch/copula/blob/master/algorithms/frankcopularnd.m

function U = frank_copula(seed, theta, d, n)
    rng(seed);
    
    p = -1.0*expm1(-1*theta);
    if (abs(1 - p) <= eps(p))
        % boundary protection
        p = 1 - eps;
    end
    
    v = logserrnd(n, p);
    v = repmat(v, 1, d);

    % sample N independent uniform random variables
    x_i = rand(n,d);
    t = -1*log(x_i)./v;

    U = -1.0*log1p( exp(-t)*expm1(-1.0*theta))/theta;


end % function