% generate gumbel copula
function U = gumbel_copula(seed, theta, d, n)
    rng(seed);
    %simulate a positive stable variate
    alpha  = 1.0/theta;
    gamma  = cos(pi/(2.0*theta)).^theta;
    delta  = 0;
    v = stable1rnd(n,alpha,gamma,delta);
    %simulate d independent standard uniforms
    x = rand(n,d);
    %return U
    t = -1*log(x)./v;
    U = exp(-1*(t.^(1.0/theta)));
   
end