%gaussian_copula(seed, P, n)
%t_copula(seed, P, nu, n)
%clayton_copula(seed, theta, d, n)
%gumbel_copula(seed, theta, d, n)
%frank_copula(seed, theta, d, n)
clear all
clc

%simulate data for copulas
P=[1 0.7; 0.7 1];
sim_gaussian=gaussian_copula(1,P,2000);
sim_gumbel=gumbel_copula(1, 2, 2, 2000);
sim_clayton=clayton_copula(1, 2.2, 2, 2000);
sim_t=t_copula(1, P, 4, 2000);

%plot figure 5.3
figure;
subplot(2,2,1);
plot(sim_gaussian(:,1), sim_gaussian(:,2),'.');
title('Gaussian');
subplot(2,2,2)
plot(sim_gumbel(:,1),sim_gumbel(:,2),'.');
title('Gumbel');
subplot(2,2,3);
plot(sim_clayton(:,1), sim_clayton(:,2),'.');
title('Clayton');
subplot(2,2,4)
plot(sim_t(:,1),sim_t(:,2),'.');
title('t');

%sample from simulated copulas with standard normal margins
z_sampled_g=norminv(sim_gaussian);
z_sampled_gum=norminv(sim_gumbel);
z_sampled_clayton=norminv(sim_clayton);
z_sampled_t=norminv(sim_t);

%plot figure 5.4
figure;
subplot(2,2,1);
plot(z_sampled_g(:,1), z_sampled_g(:,2),'.');
title('Gaussian');
subplot(2,2,2)
plot(z_sampled_gum(:,1), z_sampled_gum(:,2),'.');
title('Gumbel');
subplot(2,2,3);
plot(z_sampled_clayton(:,1), z_sampled_clayton(:,2),'.');
title('Clayton');
subplot(2,2,4)
plot(z_sampled_t(:,1),z_sampled_t(:,2),'.');
title('t');













