%source: https://github.com/stochasticresearch/copula/tree/master/algorithms/R_ports_helpers

function [ y ] = stable0rnd(alpha)
    if(alpha == 1) 
        y = 1.0;
    else
        U = rand();
        condition = 1;
        while condition
            % generate non-zero exponential random variable
            W = exprnd(1);
            condition = (W==0);
        end
        y = ( A(pi*U,alpha)/(W^(1.0-alpha)) )^(1.0/alpha);
    end
end

function [ y ] = A(x, alpha)
    Ialpha = 1.0-alpha;
    y = A_3(x, alpha, Ialpha);
end

function [ y ] = A_3(x, alpha, Ialpha)
    y = sin(alpha*x)^alpha * sin((Ialpha)*x)^(Ialpha) / sin(x);
end